import Youtube from 'ytdl-core'
import {EventEmitter} from 'events'
class Server extends EventEmitter{
	
	constructor(){
		var server= this.server= new core.VW.Http.Server()
		this.server.port=0
		this.server.timeout= 500000
		this.id=0
		
	}

	async init(){
		var server= this.server
		this.initServer()

		this.emit("init")
		await server.listen()

		this.emit("listen")
		//this.console.log("Proxy disponible: 127.0.0.1:", server.port)
		while(true){
			var reqArgs= await server.acceptAsync()
			this._continue(reqArgs);
		}
	}


	get port(){
		return this.server.port
	}

	async _continue(req){
		var time= new Date()
		var id= ++this.id
		req.id= id
		
		try{
			req.request.url=req.request.url.trim()
			//this.console.request(req.request.method, req.request.url, " ID: ", id)
			await req.catch(req.continue)
			//this.console.info("Solicitud completa: ", id, " Tiempo: ", new Date()-time, "ms")
		}
		catch(e){
			try{
				req.response.statusCode=500
				try{req.response.write(JSON.stringify({error:e.stack},4,'\t'));}catch(ex){}
				req.response.end()
			}
			catch(ex){}
		}
	}



	



	initServer(){
		var router= this.server.router
		router.use("/download/:id", async (args)=>{

			var params= args.request.params
			var yurl= params.id, info
			if(!yurl)
				throw new core.System.Exception("La url es incorrecta")

			Youtube(yurl, {
				timeout: 500000
			})
			.on("error", (e)=>{
				args.response.emit("error",e)
			})
			.on("info", (info,format)=>{
				args.response.setHeader("Content-type", format.type)
				args.response.setHeader("Content-disposition", "Attachment; filename=videoplayback." + format.container)
			})
			.pipe(args.response)

		})
	}

}
export default Server